

'ENEMY MAKER

'S to Save
'W to Edit Weapons for each enemy
'<  >  Change enemy

'Change the directory to the game files



SCREEN _NEWIMAGE(800, 600, 32)
Layer = _NEWIMAGE(800, 600)


_SCREENMOVE _MIDDLE

_DEST Layer

DIM SHARED MouseX AS INTEGER, MouseY AS INTEGER
DIM SHARED MouseLB AS _BIT, MouseRB AS _BIT, MouseMB AS _BIT
DIM SHARED MouseScrl AS _BYTE

DIM SHARED MainDir AS STRING, DataDir AS STRING, PicDir AS STRING

MainDir = "c:\qb64\air attack\"
DataDir = MainDir + "data\"
PicDir = MainDir + "pics\"

DIM SHARED FileList(200) AS STRING * 16
DIM SHARED Picture(8) AS INTEGER

TYPE EnemyStats
  MaxSpeed AS SINGLE '
  Armor AS LONG '
  Thrust AS SINGLE '
  Turn AS SINGLE '
  FileName AS STRING * 16 '
  Name AS STRING * 16 '
  Engage AS LONG '            How far away from the player the enemy will engage
  Ground AS _BYTE '          Is it confined to the ground?  '1 = yes (tank) '0 = no (jet)
  Collect AS _BYTE '         Can you collect it? Powerup?
  PowerUp AS LONG '          How much does it affect the affected stat?
  Scrap AS INTEGER '         How Much Is Its Destruction Worth?
  Size AS INTEGER '          How big is it?

END TYPE


DIM Enemy(100) AS EnemyStats

TYPE WeaponStats
  WeaponType AS INTEGER
  '1  Bullet
  '2  Missile
  '3  Laser
  '4  Heat Seek
  '5  Ray (infinite distance instantly

  Damage AS SINGLE
  Speed AS SINGLE
  Ammo AS LONG
  Refire AS LONG
  Range AS LONG '   How close the weapon needs to be
  Ang AS SINGLE '   How close the angle needs to be

  Use AS _BYTE
END TYPE


DIM SHARED Weapon(100, 10) AS WeaponStats


FOR i = 1 TO 8
  Picture(i) = _NEWIMAGE(150, 100)
NEXT
PicNew = _NEWIMAGE(150, 100)
DIM SHARED TempPic(150, 100) AS LONG

OPEN DataDir + "files.jml" FOR INPUT AS #1
DO
  FileCount = FileCount + 1
  INPUT #1, FileList(FileCount)
LOOP UNTIL EOF(1)
CLOSE #1

Sel = 1
FirstTime = 1

IF _FILEEXISTS(DataDir + "Bad.jml") THEN
  OPEN DataDir + "bad.jml" FOR BINARY AS #1
  GET #1, , Enemy()
  GET #1, , Weapon()
  CLOSE #1
END IF


'FOR i = 1 TO 100
'  Enemy2(i).MaxSpeed = Enemy(i).MaxSpeed
'  Enemy2(i).Armor = Enemy(i).Armor
'  Enemy2(i).Thrust = Enemy(i).Thrust
'  Enemy2(i).Turn = Enemy(i).Turn
'  Enemy2(i).FileName = Enemy(i).FileName
'  Enemy2(i).Name = Enemy(i).Name
'  Enemy2(i).Ground = Enemy(i).Ground
'  Enemy2(i).Collect = Enemy(i).Collect
'  Enemy2(i).PowerUp = Enemy(i).PowerUp
'  Enemy2(i).Affect = Enemy(i).Affect
'  Enemy2(i).Size = Enemy(i).Size
'NEXT



DO
  CLS

  _PRINTSTRING (40, 20), "Enemy       : " + STR$(Which)

  _PRINTSTRING (40, 100), "Name        : " + Enemy(Which).Name
  _PRINTSTRING (40, 120), "File        : " + Enemy(Which).FileName
  _PRINTSTRING (40, 140), "Speed       : " + STR$(INT(Enemy(Which).MaxSpeed * 100))
  _PRINTSTRING (40, 160), "Thrust      : " + STR$(INT(Enemy(Which).Thrust * 10000) / 10000)
  _PRINTSTRING (40, 180), "Armor       : " + STR$(Enemy(Which).Armor)
  _PRINTSTRING (40, 200), "Turn        : " + STR$(INT(Enemy(Which).Turn * 1000) / 1000)
  _PRINTSTRING (40, 220), "Engage      : " + STR$(Enemy(Which).Engage)
  _PRINTSTRING (40, 240), "Size        : " + STR$(Enemy(Which).Size)
  _PRINTSTRING (40, 260), "Fly         : " + Fly$
  _PRINTSTRING (40, 280), "Scrap Worth : " + STR$(Enemy(Which).Scrap)

  '_PRINTSTRING (40, 280), "Collectible : " + Collect$

  _PRINTSTRING (40, 360), "Speed    :  (0 to 20)"
  _PRINTSTRING (40, 380), "Thrust   :  (0 to 10)"
  _PRINTSTRING (40, 400), "Armor    :  (0 to 10000)"
  _PRINTSTRING (40, 420), "Turn     :  (0 to 1)"


  'IF Enemy(Which).Collect = 1 THEN
  '  Collect$ = "Yes"
  '  _PRINTSTRING (40, 300), "Power       : " + STR$(Enemy(Which).PowerUp)

  'ELSE
  '  Collect$ = "No"
  'END IF

  IF Enemy(Which).Ground = 0 THEN
    Fly$ = "Yes"
  ELSE
    Fly$ = "No"
  END IF

  _PRINTSTRING (20, Sel * 20 + 80), CHR$(16)

  Press = _KEYHIT

  OldSel = Sel
  SELECT CASE Press
    CASE 44, 60 '  <
      Which = Which - 1
    CASE 46, 62 '  >
      Which = Which + 1
    CASE 256 * 72: Sel = Sel - 1
    CASE 256 * 75: Add = -1
    CASE 256 * 77: Add = 1
    CASE 256 * 80: Sel = Sel + 1
    CASE 83, 115 '   S
      OPEN DataDir + "Bad.jml" FOR BINARY AS #1
      PUT #1, , Enemy()
      PUT #1, , Weapon()
      CLOSE #1
    CASE 100305, 100306: CtrlPress = 1
    CASE -100305, -100306: CtrlPress = 0
    CASE 100307, 100308: AltPress = 1
    CASE -100307, -100308: AltPress = 0

    CASE 87, 119 '    W
      GOSUB MakeWeapon
    CASE 13
      GOSUB NameObject
  END SELECT
  IF Which < 1 THEN: Which = 1
  IF Which > 100 THEN: Which = 100
  IF Sel < 1 THEN: Sel = 1
  IF Sel > 10 THEN: Sel = 10

  IF Add <> 0 THEN
    SELECT CASE CtrlPress
      CASE 0
        SELECT CASE AltPress
          CASE 1
            Add = Add * .1
        END SELECT
      CASE 1
        SELECT CASE AltPress
          CASE 0
            Add = Add * 10
          CASE 1
            Add = Add * 100
        END SELECT
    END SELECT
    SELECT CASE Sel
      CASE 3: Enemy(Which).MaxSpeed = Enemy(Which).MaxSpeed + .1 * Add
      CASE 4: Enemy(Which).Thrust = Enemy(Which).Thrust + .001 * Add
      CASE 5: Enemy(Which).Armor = Enemy(Which).Armor + 10 * Add
      CASE 6: Enemy(Which).Turn = Enemy(Which).Turn + .001 * Add
      CASE 7: Enemy(Which).Engage = Enemy(Which).Engage + 10 * Add
      CASE 8: Enemy(Which).Size = Enemy(Which).Size + Add
      CASE 9
        IF Add < 0 THEN
          Enemy(Which).Ground = 1
        ELSE
          Enemy(Which).Ground = 0
        END IF
      CASE 10: Enemy(Which).Scrap = Enemy(Which).Scrap + 10 * Add
        'IF Add < 0 THEN
        '  Enemy(Which).Collect = 0
        'ELSE
        '  Enemy(Which).Collect = 1
        'END IF

        'CASE 11
        '  IF Enemy(Which).Collect = 1 THEN
        '    Enemy(Which).PowerUp = Enemy(Which).PowerUp + 10 * Add
        '  END IF
        'CASE 12

    END SELECT
    Add = 0
  END IF
  DIM PicType AS _BYTE
  IF OldWhich <> Which OR FirstTime = 1 THEN
    FirstTime = 0
    File$ = PicDir + RTRIM$(Enemy(Which).FileName) + ".jml"
    IF _FILEEXISTS(File$) THEN
      OPEN File$ FOR BINARY AS #1
      GET #1, , PicType
      FOR i = 1 TO 8
        GET #1, , TempPic()

        _DEST Picture(i)
        CLS
        FOR x = 0 TO 149
          FOR y = 0 TO 99
            PSET (x, y), TempPic(x, y)
          NEXT
        NEXT
        _DEST Layer
      NEXT
      CLOSE #1
    END IF
  END IF

  Mouse

  CurFrame = CurFrame + 1
  IF CurFrame > 8 * 10 THEN: CurFrame = 0
  WhichFrame = INT(CurFrame / 10) + 1
  IF WhichFrame < 1 THEN: WhichFrame = 1
  IF WhichFrame > 8 THEN: WhichFrame = 8

  IF Enemy(Which).MaxSpeed < 0 THEN: Enemy(Which).MaxSpeed = 0
  IF Enemy(Which).Thrust < 0 THEN: Enemy(Which).Thrust = 0
  IF Enemy(Which).Armor < 0 THEN: Enemy(Which).Armor = 0
  IF Enemy(Which).Turn < 0 THEN: Enemy(Which).Turn = 0

  _LIMIT 30

  _PUTIMAGE (400, 100)-(700, 300), Picture(WhichFrame), Layer
  PCOPY Layer, 0
LOOP



NameObject:

SELECT CASE Sel
  CASE 1
    DO
      _PRINTSTRING (400, 20), "Name of Object"
      _PRINTSTRING (400, 40), Name$ + "     "
      P2 = _KEYHIT
      Done = 0
      SELECT CASE P2
        CASE 32, 48 TO 57, 65 TO 90, 97 TO 122
          IF LEN(Name$) < 16 THEN: Name$ = Name$ + CHR$(P2)
        CASE 8
          IF LEN(Name$) > 0 THEN: Name$ = LEFT$(Name$, LEN(Name$) - 1)
        CASE 13: Done = 1
        CASE 27: Done = 2

      END SELECT
      _LIMIT 30
      PCOPY Layer, 0
    LOOP UNTIL Done > 0
    IF Done = 1 THEN: Enemy(Which).Name = Name$
  CASE 2
    FirstTime = 1
    DO
      _PRINTSTRING (400, 20), "Select a Picture"
      P2 = _KEYHIT
      OldPicSel = PicSel
      Done = 0
      SELECT CASE P2
        CASE 256 * 75: PicSel = PicSel - 1
        CASE 256 * 77: PicSel = PicSel + 1
        CASE 27: Done = 2
        CASE 13: Done = 1
      END SELECT
      IF PicSel < 1 THEN: PicSel = 1
      IF PicSel > FileCount THEN: PicSel = FileCount
      IF OldPicSel <> PicSel OR FirstTime = 1 THEN
        FirstTime = 0
        FileSel$ = PicDir + RTRIM$(FileList(PicSel)) + ".jml"
        IF _FILEEXISTS(FileSel$) THEN
          OPEN FileSel$ FOR BINARY AS #1
          GET #1, , PicType
          FOR i = 1 TO 5
            GET #1, , TempPic()
          NEXT
          _DEST PicNew
          FOR x = 0 TO 149
            FOR y = 0 TO 99
              PSET (x, y), TempPic(x, y)
            NEXT
          NEXT
          CLOSE #1
          _DEST Layer
        END IF
      END IF
      _PUTIMAGE (400, 100)-(700, 300), PicNew, Layer
      _PRINTSTRING (400, 320), FileList(PicSel)
      _LIMIT 30
      PCOPY Layer, 0
    LOOP UNTIL Done > 0
    IF Done = 1 THEN
      Enemy(Which).FileName = FileList(PicSel)
      FirstTime = 1
    END IF

END SELECT
RETURN



MakeWeapon:

WhichWep = 1

DO
  CLS

  Press = _KEYHIT


  LINE (50, 50)-(450, 550), _RGB32(255, 0, 0), B
  Done = 0
  SELECT CASE Weapon(Which, WhichWep).WeaponType
    CASE 1: WepType$ = "Bullet"
    CASE 2: WepType$ = "Missile"
    CASE 3: WepType$ = "Laser"
    CASE 4: WepType$ = "Heat Seeking"
    CASE 5: WepType$ = "Flak"
  END SELECT

  SELECT CASE Press
    CASE 100305, 100306: CtrlPress = 1
    CASE -100305, -100306: CtrlPress = 0
    CASE 100307, 100308: AltPress = 1
    CASE -100307, -100308: AltPress = 0

    CASE 46, 62 '>
      WhichWep = WhichWep + 1
    CASE 44, 60
      WhichWep = WhichWep - 1
    CASE 256 * 72: WepSel = WepSel - 1
    CASE 256 * 75: Add = -1
    CASE 256 * 77: Add = 1
    CASE 256 * 80: WepSel = WepSel + 1
    CASE 27: Done = 1
  END SELECT

  IF WepSel < 1 THEN: WepSel = 1
  IF WepSel > 8 THEN: WepSel = 8

  IF Add <> 0 THEN
    SELECT CASE CtrlPress
      CASE 0
        SELECT CASE AltPress
          CASE 0: AddTot = Add
          CASE 1: AddTot = Add / 10
        END SELECT
      CASE 1
        SELECT CASE AltPress
          CASE 0: AddTot = Add * 10
          CASE 1: AddTot = Add * 100
        END SELECT
    END SELECT
    SELECT CASE WepSel
      CASE 1: WhichWep = WhichWep + AddTot
      CASE 2: Weapon(Which, WhichWep).WeaponType = Weapon(Which, WhichWep).WeaponType + AddTot
      CASE 3: Weapon(Which, WhichWep).Damage = Weapon(Which, WhichWep).Damage + AddTot * 10
      CASE 4: Weapon(Which, WhichWep).Speed = Weapon(Which, WhichWep).Speed + AddTot * 100
      CASE 5: Weapon(Which, WhichWep).Ammo = Weapon(Which, WhichWep).Ammo + AddTot * 1
      CASE 6: Weapon(Which, WhichWep).Refire = Weapon(Which, WhichWep).Refire + AddTot
      CASE 7: Weapon(Which, WhichWep).Range = Weapon(Which, WhichWep).Range + AddTot * 10
      CASE 8: Weapon(Which, WhichWep).Ang = Weapon(Which, WhichWep).Ang + AddTot / 10
    END SELECT
    Add = 0
  END IF

  IF WhichWep < 1 THEN: WhichWep = 1
  IF WhichWep > 10 THEN: WhichWep = 10
  IF Weapon(Which, WhichWep).WeaponType < 1 THEN: Weapon(Which, WhichWep).WeaponType = 1
  IF Weapon(Which, WhichWep).WeaponType > 5 THEN: Weapon(Which, WhichWep).WeaponType = 5

  IF Weapon(Which, WhichWep).Damage < 0 THEN: Weapon(Which, WhichWep).Damage = 0
  IF Weapon(Which, WhichWep).Speed < 0 THEN: Weapon(Which, WhichWep).Speed = 0
  IF Weapon(Which, WhichWep).Ammo < 0 THEN: Weapon(Which, WhichWep).Ammo = 0
  IF Weapon(Which, WhichWep).Refire < 1 THEN: Weapon(Which, WhichWep).Refire = 1
  IF Weapon(Which, WhichWep).Ang < 0 THEN: Weapon(Which, WhichWep).Ang = 0
  IF Weapon(Which, WhichWep).Range < 0 THEN: Weapon(Which, WhichWep).Range = 0

  _PRINTSTRING (100, 80), "Weapon: " + STR$(WhichWep)

  _PRINTSTRING (100, 140), "Type   :  " + WepType$
  _PRINTSTRING (100, 160), "Damage : " + STR$(Weapon(Which, WhichWep).Damage)
  _PRINTSTRING (100, 180), "Speed  : " + STR$(Weapon(Which, WhichWep).Speed)
  _PRINTSTRING (100, 200), "Ammo   : " + STR$(Weapon(Which, WhichWep).Ammo)
  _PRINTSTRING (100, 220), "Refire : " + STR$(Weapon(Which, WhichWep).Refire)
  _PRINTSTRING (100, 240), "Range  : " + STR$(Weapon(Which, WhichWep).Range)
  _PRINTSTRING (100, 260), "Angle  : " + STR$(Weapon(Which, WhichWep).Ang)


  IF Weapon(Which, WhichWep).Refire < 30 THEN
    _PRINTSTRING (240, 220), STR$(INT(3000 / Weapon(Which, WhichWep).Refire) / 100) + " Shots per second"
  ELSEIF Weapon(Which, WhichWep).Refire >= 30 THEN
    _PRINTSTRING (240, 220), STR$(INT(Weapon(Which, WhichWep).Refire / .3) / 100) + " Seconds per shot"
  END IF

  IF WepSel = 1 THEN
    _PRINTSTRING (80, 80), CHR$(16)
  ELSE
    _PRINTSTRING (80, WepSel * 20 + 100), CHR$(16)
  END IF


  PCOPY Layer, 0
LOOP UNTIL Done = 1

RETURN


SUB Mouse
DO WHILE _MOUSEINPUT
  MouseX = _MOUSEX
  MouseY = _MOUSEY
  MouseLB = _MOUSEBUTTON(1)
  MouseRB = _MOUSEBUTTON(2)
  MouseMB = _MOUSEBUTTON(3)
  MouseScrl = MouseScrl + _MOUSEWHEEL
LOOP
IF MouseScrl < -1 THEN: MouseScrl = -1
IF MouseScrl > 1 THEN: MouseScrl = 1
END SUB

FUNCTION Distance (X1, Y1, X2, Y2)
Distance = sqrt((X1 - X2) * (X1 - X2) + (Y1 - Y2) * (Y1 - Y2))
END FUNCTION
