'Painter


'S saves
'L loads  (Press Del to delete files while in load screen)
'M mirror images a picture.  Move mouse to select side.  Escape cancels.  M again confirms.
'F flips a picture
'C copies a picture
'P pastes a picture
'<  >  Changes current angle
'Arrow keys move picture  (clips off edges)
'1 = Paint
'2 = Line
'3 = Circle


SCREEN _NEWIMAGE(800, 600, 32)
Layer = _NEWIMAGE(800, 600)
_SCREENMOVE _MIDDLE

OverLay = _NEWIMAGE(200, 150)
DrawLayer = _NEWIMAGE(200, 150)

FilePage = _NEWIMAGE(400, 300)
MirrorPic = _NEWIMAGE(150, 100)
FlipPic = _NEWIMAGE(150, 100)
CopyPic = _NEWIMAGE(150, 100)


_TITLE "Air Attack Painter"


CONST Rad = 180 / 3.14159265

DIM TempPic(150, 100) AS LONG
DIM TempPicWep(30, 20) AS LONG
DIM FileList(200) AS STRING

DIM SHARED MouseX AS INTEGER, MouseY AS INTEGER, MouseLB AS _BIT, MouseRB AS _BIT, MouseMB AS _BIT, MouseScrl AS _BYTE
DIM SHARED ColorWheel AS INTEGER, CurrentFile AS STRING

DIM SHARED PenSize AS INTEGER, MaxPenSize AS INTEGER

DIM SHARED EditType AS _BYTE

DIM PaintCol AS LONG

DIM MainDir AS STRING, DataDir AS STRING, PicDir AS STRING

MainDir = "c:\qb64\air attack\"
DataDir = MainDir + "data\"
PicDir = MainDir + "pics\"

ColorWheel = _NEWIMAGE(500, 500)
MakeColorWheel

_DEST Layer

TYPE Col
  R AS INTEGER
  G AS INTEGER
  B AS INTEGER
  Col AS LONG
END TYPE

DIM Col AS Col
DIM Old AS Col

DIM Picture(8) AS INTEGER
DIM Picture2(8) AS INTEGER
FOR i = 1 TO 8
  Picture(i) = _NEWIMAGE(150, 100)
  _DEST Picture(i)
  LINE (0, 0)-(599, 399), _RGB32(0, 0, 0), BF
NEXT

DIM SHARED LoadPic(8) AS INTEGER
FOR i = 1 TO 8
  LoadPic(i) = _NEWIMAGE(150, 100)
NEXT
DIM SHARED LoadPicWep(8) AS INTEGER
FOR i = 1 TO 8
  LoadPicWep(i) = _NEWIMAGE(30, 20)
NEXT



_DEST Layer

_PRINTMODE _KEEPBACKGROUND

DO
  CLS

  Mouse
  SELECT CASE EditType
    CASE 0: MaxPenSize = 25
    CASE 1: MaxPenSize = 10
  END SELECT

  LINE (0, 0)-(616, 416), _RGB32(180, 0, 0), BF

  SELECT CASE EditType
    CASE 0
      _PUTIMAGE (8, 8)-(607, 407), Picture(CurrentAngle + 1)
      _PUTIMAGE (10, 435)-(160, 585), ColorWheel, Layer
    CASE 1
      _PUTIMAGE (8, 8)-(607, 407), Picture(CurrentAngle + 1), Layer, (0, 0)-(29, 19)
      _PUTIMAGE (10, 435)-(160, 585), ColorWheel, Layer
  END SELECT

  LINE (200, 442)-(500, 448), _RGB32(255, 0, 0), BF
  LINE (200, 467)-(500, 473), _RGB32(0, 255, 0), BF
  LINE (200, 492)-(500, 498), _RGB32(0, 0, 255), BF

  X = 200 + (Col.R / 255) * 295
  LINE (X, 435)-(X + 5, 455), _RGB32(128, 128, 128), BF
  X = 200 + (Col.G / 255) * 295
  LINE (X, 460)-(X + 5, 480), _RGB32(128, 128, 128), BF
  X = 200 + (Col.B / 255) * 295
  LINE (X, 485)-(X + 5, 505), _RGB32(128, 128, 128), BF

  LINE (250, 535)-(270, 555), _RGB32(Col.R, 0, 0), BF
  LINE (300, 535)-(320, 555), _RGB32(0, Col.G, 0), BF
  LINE (350, 535)-(370, 555), _RGB32(0, 0, Col.B), BF
  LINE (250, 535)-(270, 555), _RGB32(64, 64, 64), B
  LINE (300, 535)-(320, 555), _RGB32(64, 64, 64), B
  LINE (350, 535)-(370, 555), _RGB32(64, 64, 64), B

  LINE (400, 515)-(460, 575), Col.Col, BF
  LINE (400, 515)-(460, 575), _RGB32(64, 64, 64), B

  _PRINTSTRING (250, 515), "Red"
  _PRINTSTRING (300, 515), "Green"
  _PRINTSTRING (350, 515), "Blue"
  _PRINTSTRING (250, 565), LTRIM$(STR$(Col.R))
  _PRINTSTRING (300, 565), LTRIM$(STR$(Col.G))
  _PRINTSTRING (350, 565), LTRIM$(STR$(Col.B))

  _PRINTSTRING (525, 423), "Pen"
  _PRINTSTRING (520, 580), STR$(PenSize)

  LINE (532, 440)-(538, 575), _RGB32(64, 64, 64), BF
  LINE (525, 435 + (PenSize / MaxPenSize) * 130)-(545, 445 + (PenSize / MaxPenSize) * 130), _RGB32(128, 128, 128), BF

  IF PaintDraw > 0 THEN
    LINE (640, 260)-(670, 290), _RGB32(255, 0, 0), BF
  ELSE
    LINE (640, 260)-(670, 290), _RGB32(255, 0, 0), B
  END IF
  IF LineDraw > 0 THEN
    LINE (640, 320)-(670, 350), _RGB32(255, 0, 0), BF
  ELSE
    LINE (640, 320)-(670, 350), _RGB32(255, 0, 0), B
  END IF
  IF CircleDraw > 0 THEN
    LINE (640, 380)-(670, 410), _RGB32(255, 0, 0), BF
  ELSE
    LINE (640, 380)-(670, 410), _RGB32(255, 0, 0), B
  END IF

  _PRINTSTRING (650, 268), "P"
  _PRINTSTRING (650, 328), "L"
  _PRINTSTRING (650, 388), "C"

  IF EditType = 0 THEN
    LINE (640, 430)-(710, 460), _RGB32(55, 0, 0), BF
  ELSE
    LINE (640, 470)-(710, 500), _RGB32(55, 0, 0), BF
  END IF
  LINE (640, 430)-(710, 460), _RGB32(255, 0, 0), B
  LINE (640, 470)-(710, 500), _RGB32(255, 0, 0), B


  _PRINTSTRING (650, 438), "Enemy"
  _PRINTSTRING (650, 478), "Weapon"

  AngleGetX = 720
  AngleGetY = 80
  CIRCLE (AngleGetX, AngleGetY), 50
  X = AngleGetX + COS(((CurrentAngle * 45) - 90) / Rad) * 50
  Y = AngleGetY + SIN(((CurrentAngle * 45) - 90) / Rad) * 50
  LINE (AngleGetX, AngleGetY)-(X, Y), _RGB32(255, 255, 0)

  FOR i = 0 TO 7
    X = AngleGetX + COS((i * 45 - 90) / Rad) * 65
    Y = AngleGetY + SIN((i * 45 - 90) / Rad) * 65
    CIRCLE (X, Y), 8, _RGB32(192, 192, 192)
    IF i = CurrentAngle THEN
      PAINT (X, Y), _RGB32(225, 225, 225), _RGB32(192, 192, 192)
    END IF
  NEXT

  _PRINTSTRING (AngleGetX - 12, AngleGetY + 170), "You"
  CIRCLE (AngleGetX, AngleGetY + 150), 20
  LINE (AngleGetX, AngleGetY + 150)-(AngleGetX, AngleGetY + 130)
  LINE (AngleGetX - 5, AngleGetY + 135)-(AngleGetX, AngleGetY + 130)
  LINE (AngleGetX + 5, AngleGetY + 135)-(AngleGetX, AngleGetY + 130)

  _DEST OverLay
  CLS , _RGBA32(0, 0, 0, 0)

  SELECT CASE EditType
    CASE 0: Size = 4
    CASE 1: Size = 20
  END SELECT


  SELECT CASE MouseStatus
    CASE 0: _MOUSESHOW
    CASE 2: _MOUSEHIDE
  END SELECT

  IF PaintDraw = 2 THEN

    _PUTIMAGE (2, 2)-(151, 101), Picture(CurrentAngle + 1), OverLay
    _SOURCE OverLay

    PaintToX = INT(MouseX / Size)
    PaintToY = INT(MouseY / Size)
    PaintCol = POINT(PaintToX, PaintToY)

    PAINT (INT(PaintX / Size), INT(PaintY / Size)), Col.Col, PaintCol
  ELSEIF PaintDraw = 3 THEN
    PaintDraw = 0
    _DEST Picture(CurrentAngle + 1)

    _PUTIMAGE (2, 2)-(151, 101), Picture(CurrentAngle + 1), OverLay
    _SOURCE OverLay

    'PaintToX = INT(MouseX / Size)
    'PaintToY = INT(MouseY / Size)
    'PaintCol = POINT(PaintToX, PaintToY)
    PAINT (INT(PaintX / Size) - 2, INT(PaintY / Size) - 2), Col.Col, PaintCol

    _DEST OverLay
  END IF


  IF LineDraw = 2 THEN
    SELECT CASE EditType
      CASE 0
        LINE (INT(LineStartX / Size), INT(LineStartY / Size))-(INT(MouseX / Size), INT(MouseY / Size)), Col.Col
      CASE 1
        LINE (INT(LineStartX / Size) + 1, INT(LineStartY / Size) + 1)-(INT(MouseX / Size) + 1, INT(MouseY / Size) + 1), Col.Col
    END SELECT
  ELSEIF LineDraw = 3 THEN
    _DEST Picture(CurrentAngle + 1)
    LineDraw = 0
    SELECT CASE EditType
      CASE 0
        LINE (INT(LineStartX / Size) - 2, INT(LineStartY / Size) - 2)-(INT(LineEndX / Size) - 2, INT(LineEndY / Size) - 2), Col.Col
      CASE 1
        LINE (INT(LineStartX / Size) - 1, INT(LineStartY / Size) - 1)-(INT(LineEndX / Size) - 1, INT(LineEndY / Size) - 1), Col.Col
    END SELECT
    _DEST OverLay
  END IF

  IF CircleDraw = 2 THEN
    SELECT CASE EditType
      CASE 0
        CIRCLE (INT(CircleX / Size), INT(CircleY / Size)), Distance(CircleX, CircleY, MouseX, MouseY) / Size, Col.Col
      CASE 1
        CIRCLE (INT(CircleX / Size) + 1, INT(CircleY / Size) + 1), Distance(CircleX, CircleY, MouseX, MouseY) / Size, Col.Col
    END SELECT
  ELSEIF CircleDraw = 3 THEN
    _DEST Picture(CurrentAngle + 1)
    CircleDraw = 0
    SELECT CASE EditType
      CASE 0
        CIRCLE (INT(CircleX / Size) - 2, INT(CircleY / Size) - 2), Distance(CircleX, CircleY, MouseX, MouseY) / Size, Col.Col
      CASE 1
        CIRCLE (INT(CircleX / Size) - 1, INT(CircleY / Size) - 1), Distance(CircleX, CircleY, MouseX, MouseY) / Size, Col.Col
    END SELECT

    _DEST OverLay
  END IF


  IF MouseX >= 8 AND MouseX <= 608 AND MouseY >= 8 AND MouseY <= 408 THEN
    SELECT CASE MouseStatus
      CASE 2
        MouseStatus = 3
      CASE 0, 1
        MouseStatus = 2
    END SELECT

    IF ColorPick = 0 AND LineDraw = 0 AND PaintDraw = 0 AND CircleDraw = 0 THEN
      FOR X = -PenSize - 1 TO PenSize + 1
        FOR Y = -PenSize - 1 TO PenSize + 1
          Dist = Distance(X, Y, 0, 0)
          SELECT CASE EditType
            CASE 0
              DrawX = INT(MouseX / Size) + X
              DrawY = INT(MouseY / Size) + Y
            CASE 1
              DrawX = INT(MouseX / Size) + X + 1
              DrawY = INT(MouseY / Size) + Y + 1
          END SELECT
          IF DrawX > 1 AND DrawX < 152 AND DrawY > 1 AND DrawY < 102 THEN
            IF Dist < PenSize THEN
              SELECT CASE EditType
                CASE 0: PSET (DrawX, DrawY), Col.Col
                CASE 1: LINE (DrawX * 5 - 8, DrawY * 5 - 8)-(DrawX * 5 - 4, DrawY * 5 - 4), Col.Col, BF
              END SELECT
            ELSEIF Dist >= PenSize AND Dist <= PenSize + 1 THEN
              SELECT CASE EditType
                CASE 0: PSET (DrawX, DrawY), _RGBA32(192, 192, 192, 128)
                CASE 1: 'LINE (DrawX * 5 - 5, DrawY * 5 - 5)-(DrawX * 5, DrawY * 5), _RGBA(192, 192, 192, 128), BF
              END SELECT
            END IF
          END IF
        NEXT
      NEXT
    ELSE
      SELECT CASE EditType
        CASE 0
          FOR X = -2 TO 2
            FOR Y = -2 TO 2
              Dist = Distance(X, Y, 0, 0)
              DrawX = INT(MouseX / Size) + X
              DrawY = INT(MouseY / Size) + Y
              IF DrawX > 1 AND DrawX < 152 AND DrawY > 1 AND DrawY < 102 THEN
                IF Dist >= 1 AND Dist <= 2 THEN: PSET (DrawX, DrawY), _RGBA32(192, 192, 192, 128)
              END IF
            NEXT
          NEXT
        CASE 1
          DrawX = INT(MouseX / Size) + 1
          DrawY = INT(MouseY / Size) + 1
          LINE (DrawX * 5 - 8, DrawY * 5 - 8)-(DrawX * 5 - 4, DrawY * 5 - 4), _RGBA32(192, 192, 192, 128), BF
      END SELECT
    END IF

  ELSE
    SELECT CASE MouseStatus
      CASE 0
        MouseStatus = 1
      CASE 2, 3
        MouseStatus = 0
    END SELECT
  END IF
  _DEST Layer

  IF MouseLB THEN
    IF MouseX >= 640 AND MouseX <= 710 THEN
      IF MouseY >= 430 AND MouseY <= 460 THEN: EditType = 0
      IF MouseY >= 470 AND MouseY <= 500 THEN: EditType = 1
    END IF

    IF MouseX >= 8 AND MouseX <= 608 AND MouseY >= 8 AND MouseY <= 408 THEN
      IF ColorPaste = 0 THEN
        IF LineDraw = 0 AND CircleDraw = 0 AND PaintDraw = 0 THEN
          IF ColorPick = 0 THEN
            FOR X = -PenSize - 1 TO PenSize + 1
              FOR Y = -PenSize - 1 TO PenSize + 1
                IF Distance(X, Y, 0, 0) < PenSize THEN
                  _DEST Picture(CurrentAngle + 1)
                  SELECT CASE EditType
                    CASE 0: PSET (INT(MouseX / Size) + X - 2, INT(MouseY / Size) + Y - 2), Col.Col
                    CASE 1: PSET (INT(MouseX / Size) + X - 1, INT(MouseY / Size) + Y - 1), Col.Col
                  END SELECT
                  _DEST Layer
                END IF
              NEXT
            NEXT
          ELSE
            _SOURCE Picture(CurrentAngle + 1)
            SELECT CASE EditType
              CASE 0
                Col.R = _RED32(POINT(INT(MouseX / Size) - 2, INT(MouseY / Size) - 2))
                Col.G = _GREEN32(POINT(INT(MouseX / Size) - 2, INT(MouseY / Size) - 2))
                Col.B = _BLUE32(POINT(INT(MouseX / Size) - 2, INT(MouseY / Size) - 2))
              CASE 1
                Col.R = _RED32(POINT(INT(MouseX / Size) - 1, INT(MouseY / Size) - 1))
                Col.G = _GREEN32(POINT(INT(MouseX / Size) - 1, INT(MouseY / Size) - 1))
                Col.B = _BLUE32(POINT(INT(MouseX / Size) - 1, INT(MouseY / Size) - 1))
            END SELECT
          END IF
        ELSE
          IF PaintDraw = 1 THEN
            PaintDraw = 2
            PaintX = MouseX
            PaintY = MouseY
          END IF
          IF LineDraw = 1 THEN
            LineDraw = 2
            LineStartX = MouseX
            LineStartY = MouseY
          END IF
          IF CircleDraw = 1 THEN
            CircleDraw = 2
            CircleX = MouseX
            CircleY = MouseY
          END IF

        END IF
      ELSE
        _SOURCE Layer
        ColR% = _RED32(POINT(MouseX, MouseY))
        ColG% = _GREEN32(POINT(MouseX, MouseY))
        ColB% = _BLUE32(POINT(MouseX, MouseY))
        _SOURCE Picture(CurrentAngle + 1)
        _DEST Picture(CurrentAngle + 1)
        '_TITLE STR$(_RED32(ColorReplace&)) + " " + STR$(_GREEN32(ColorReplace&)) + " " + STR$(_BLUE32(ColorReplace&)) + "     " + STR$(_RED32(Col.Col)) + " " + STR$(_GREEN32(Col.Col)) + " " + STR$(_BLUE32(Col.Col))
        SELECT CASE EditType
          CASE 0
            FOR X = 0 TO 149
              FOR Y = 0 TO 99
                '_TITLE STR$(X) + " " + STR$(Y) + "  " + STR$(_RED32(POINT(X, Y))) + "  " + STR$(_GREEN32(POINT(X, Y))) + "  " + STR$(_BLUE32(POINT(X, Y)))

                PointR% = _RED32(POINT(X, Y))
                PointG% = _GREEN32(POINT(X, Y))
                PointB% = _BLUE32(POINT(X, Y))
                IF ColR% = PointR% AND ColG% = PointG% AND ColB% = PointB% THEN
                  PSET (X, Y), Col.Col
                END IF
              NEXT
            NEXT
          CASE 1
            FOR X = 0 TO 29
              FOR Y = 0 TO 19
                IF POINT(X, Y) = ColorReplace& THEN
                  PSET (X, Y), Col.Col
                END IF
              NEXT
            NEXT
        END SELECT

        _DEST Layer
      END IF
    END IF

    IF Distance(MouseX, MouseY, 85, 510) <= 75 THEN
      _SOURCE Layer
      Col.R = _RED32(POINT(MouseX, MouseY))
      Col.G = _GREEN32(POINT(MouseX, MouseY))
      Col.B = _BLUE32(POINT(MouseX, MouseY))
    END IF
    IF Distance(MouseX, MouseY, AngleGetX, AngleGetY) <= 65 THEN
      CurrentAngle = CINT((Angle(AngleGetX, AngleGetY, MouseX, MouseY) + 90) / 45)
      IF CurrentAngle > 7 THEN: CurrentAngle = CurrentAngle - 8
      IF CurrentAngle < 0 THEN: CurrentAngle = CurrentAngle + 8
    END IF
    SELECT CASE MouseX
      CASE 190 TO 510
        SELECT CASE MouseY
          CASE 435 TO 455
            Col.R = ((MouseX - 200) / 300) * 255
          CASE 460 TO 480
            Col.G = ((MouseX - 200) / 300) * 255
          CASE 485 TO 505
            Col.B = ((MouseX - 200) / 300) * 255
        END SELECT
      CASE 525 TO 545
        SELECT CASE MouseY
          CASE 435 TO 570
            PenSize = ((MouseY - 435) / 135) * 25
        END SELECT
      CASE 640 TO 670
        SELECT CASE MouseY
          CASE 260 TO 290 'Paint
            IF CircleDraw = 0 AND LineDraw = 0 THEN
              IF PaintDraw = 0 THEN: PaintDraw = 1
            END IF
          CASE 320 TO 350 'Line
            IF CircleDraw = 0 AND PaintDraw = 0 THEN
              IF LineDraw = 0 THEN: LineDraw = 1
            END IF
          CASE 380 TO 410 'Circle
            IF LineDraw = 0 AND PaintDraw = 0 THEN
              IF CircleDraw = 0 THEN: CircleDraw = 1
            END IF
        END SELECT
    END SELECT
  ELSE
    IF PaintDraw = 2 THEN
      PaintDraw = 3
      PaintToX = MouseX
      PaintToY = MouseY
    END IF
    IF LineDraw = 2 THEN
      LineDraw = 3
      LineEndX = MouseX
      LineEndY = MouseY
    END IF
    IF CircleDraw = 2 THEN
      CircleDraw = 3
      CircleRadius = Distance(CircleX, CircleY, MouseX, MouseY)
    END IF
  END IF

  IF MouseScrl THEN
    PenSize = PenSize + MouseScrl
    MouseScrl = 0
  END IF
  IF PenSize < 1 THEN: PenSize = 1
  IF PenSize > MaxPenSize THEN: PenSize = MaxPenSize

  IF Mirror = 1 THEN
    IF MouseX > 308 THEN
      SELECT CASE EditType
        CASE 0
          _PUTIMAGE (2, 2)-(76, 101), Picture(CurrentAngle + 1), OverLay, (149, 0)-(75, 99)
        CASE 1
          _PUTIMAGE (2, 2)-(76, 101), Picture(CurrentAngle + 1), OverLay, (29, 0)-(15, 19)
      END SELECT
    ELSE
      SELECT CASE EditType
        CASE 0
          _PUTIMAGE (77, 2)-(151, 101), Picture(CurrentAngle + 1), OverLay, (74, 0)-(0, 99)
        CASE 1
          _PUTIMAGE (77, 2)-(151, 101), Picture(CurrentAngle + 1), OverLay, (14, 0)-(0, 19)
      END SELECT
    END IF
  END IF

  Press = _KEYHIT
  SELECT CASE Press


    CASE 49 'Paint
      IF CircleDraw = 0 AND LineDraw = 0 THEN
        IF PaintDraw = 0 THEN: PaintDraw = 1
      END IF
    CASE 50 'Line
      IF CircleDraw = 0 AND PaintDraw = 0 THEN
        IF LineDraw = 0 THEN: LineDraw = 1
      END IF
    CASE 51 'Circle
      IF LineDraw = 0 AND PaintDraw = 0 THEN
        IF CircleDraw = 0 THEN: CircleDraw = 1
      END IF

    CASE 67, 99 '  C
      'CopyPage = CurrentAngle + 1
      PCOPY Picture(CurrentAngle + 1), CopyPic
    CASE 80, 112 ' P
      'PCOPY Picture(CopyPage), Picture(CurrentAngle + 1)
      PCOPY CopyPic, Picture(CurrentAngle + 1)
    CASE 70, 102 ' F
      PCOPY Picture(CurrentAngle + 1), FlipPic
      SELECT CASE EditType
        CASE 0
          _PUTIMAGE (149, 0)-(0, 99), FlipPic, Picture(CurrentAngle + 1), (0, 0)-(149, 99)
        CASE 1
          _PUTIMAGE (29, 0)-(0, 19), FlipPic, Picture(CurrentAngle + 1), (0, 0)-(29, 19)
      END SELECT
    CASE 77, 109 ' M
      IF Mirror = 0 THEN
        Mirror = 1
      ELSE
        Mirror = 0
        IF MouseX > 308 THEN
          PCOPY Picture(CurrentAngle + 1), MirrorPic
          SELECT CASE EditType
            CASE 0
              _PUTIMAGE (0, 0)-(74, 99), Picture(CurrentAngle + 1), MirrorPic, (149, 0)-(75, 99)
            CASE 1
              _PUTIMAGE (0, 0)-(14, 19), Picture(CurrentAngle + 1), MirrorPic, (29, 0)-(15, 19)
          END SELECT
          PCOPY MirrorPic, Picture(CurrentAngle + 1)
        ELSE
          PCOPY Picture(CurrentAngle + 1), MirrorPic
          SELECT CASE EditType
            CASE 0
              _PUTIMAGE (75, 0)-(149, 99), Picture(CurrentAngle + 1), MirrorPic, (74, 0)-(0, 99)
            CASE 1
              _PUTIMAGE (15, 0)-(29, 19), Picture(CurrentAngle + 1), MirrorPic, (14, 0)-(0, 19)
          END SELECT
          PCOPY MirrorPic, Picture(CurrentAngle + 1)
        END IF
      END IF
    CASE 27
      IF Mirror = 1 THEN: Mirror = 0
      LineDraw = 0
      CircleDraw = 0
      PaintDraw = 0
    CASE 90, 122 'Z
      IF ColorPick = 1 THEN
        ColorPick = 0
      ELSE
        ColorPick = 1
      END IF
    CASE 76, 108 '  L
      GOSUB LoadPic
    CASE 83, 115 '   S
      GOSUB SavePic
    CASE 49: Col.R = Col.R + 5
    CASE 33: Col.R = Col.R - 5
    CASE 50: Col.G = Col.G + 5
    CASE 64: Col.G = Col.G - 5
    CASE 51: Col.B = Col.B + 5
    CASE 35: Col.B = Col.B - 5

    CASE 256 * 72
      PCOPY Picture(CurrentAngle + 1), FlipPic
      _PUTIMAGE (0, -1)-(149, 98), FlipPic, Picture(CurrentAngle + 1), (0, 0)-(149, 99)
      _DEST Picture(CurrentAngle + 1)
      LINE (0, 99)-(149, 99), _RGB32(0, 0, 0)
      _DEST Layer
    CASE 256 * 75
      PCOPY Picture(CurrentAngle + 1), FlipPic
      _PUTIMAGE (-1, 0)-(148, 99), FlipPic, Picture(CurrentAngle + 1), (0, 0)-(149, 99)
      _DEST Picture(CurrentAngle + 1)
      LINE (149, 0)-(149, 99), _RGB32(0, 0, 0)
      _DEST Layer
    CASE 256 * 77
      PCOPY Picture(CurrentAngle + 1), FlipPic
      _PUTIMAGE (1, 0)-(150, 99), FlipPic, Picture(CurrentAngle + 1), (0, 0)-(149, 99)
      _DEST Picture(CurrentAngle + 1)
      LINE (0, 0)-(0, 99), _RGB32(0, 0, 0)
      _DEST Layer
    CASE 256 * 80
      PCOPY Picture(CurrentAngle + 1), FlipPic
      _PUTIMAGE (0, 1)-(149, 100), FlipPic, Picture(CurrentAngle + 1), (0, 0)-(149, 99)
      _DEST Picture(CurrentAngle + 1)
      LINE (0, 0)-(149, 0), _RGB32(0, 0, 0)
      _DEST Layer
    CASE 69, 101 '   E
      IF ColorPaste = 0 THEN
        ColorPaste = 1
      ELSE
        ColorPaste = 0
      END IF

    CASE 44, 60: CurrentAngle = CurrentAngle - 1
    CASE 46, 62: CurrentAngle = CurrentAngle + 1

  END SELECT
  IF CurrentAngle < 0 THEN: CurrentAngle = 7
  IF CurrentAngle > 7 THEN: CurrentAngle = 0

  IF Col.R < 0 THEN: Col.R = 0
  IF Col.R > 255 THEN: Col.R = 255
  IF Col.G < 0 THEN: Col.G = 0
  IF Col.G > 255 THEN: Col.G = 255
  IF Col.B < 0 THEN: Col.B = 0
  IF Col.B > 255 THEN: Col.B = 255


  Col.Col = _RGB32(Col.R, Col.G, Col.B)

  _LIMIT 60
  IF EditType = 1 THEN
    IF CircleDraw > 1 OR LineDraw > 1 OR PaintDraw > 1 THEN
      _PUTIMAGE (8, 8)-(607, 407), OverLay, Layer, (2, 2)-(31, 21)
    ELSE
      _PUTIMAGE (8, 8)-(607, 407), OverLay, Layer, (2, 2)-(151, 101)
    END IF
  ELSE
    _PUTIMAGE (8, 8)-(607, 407), OverLay, Layer, (2, 2)-(151, 101)
  END IF

  IF ColorPaste = 1 THEN: _PRINTSTRING (600, 550), "Click Color to Replace"
  IF ColorPick = 1 THEN: _PRINTSTRING (600, 530), "COPY mode ON"


  '_PUTIMAGE (0, 0)-(799, 599), OverLay, Layer
  PCOPY Layer, 0
LOOP

SavePic:
Count = 0
IF _FILEEXISTS(DataDir + "files.jml") THEN
  OPEN DataDir + "files.jml" FOR INPUT AS #1
  DO
    Count = Count + 1
    INPUT #1, Text$
    FileList(Count) = UCASE$(Text$)
  LOOP UNTIL EOF(1)
  CLOSE #1
END IF
_DEST FilePage
DO
  CLS
  _PRINTSTRING (190, 0), "SAVE"
  _PRINTSTRING (20, 20), "Name of file: " + NewFile$
  Press = _KEYHIT
  Done = 0
  SELECT CASE Press
    CASE 32, 48 TO 57, 65 TO 90, 97 TO 122
      IF LEN(NewFile$) < 16 THEN: NewFile$ = NewFile$ + CHR$(Press)
    CASE 8
      IF LEN(NewFile$) > 0 THEN: NewFile$ = LEFT$(NewFile$, LEN(NewFile$) - 1)
    CASE 13
      Done = 1
    CASE 27
      Done = 2
  END SELECT
  _PUTIMAGE (0, 0)-(799, 599), FilePage, 0
LOOP UNTIL Done > 0
IF Done = 1 THEN
  Good = 1
  Original = 1
  OverSel = 0
  IF _FILEEXISTS(PicDir + NewFile$ + ".jml") THEN

    Original = 0
    DO
      _PRINTSTRING (200, 40), "File Already Exists!"
      _PRINTSTRING (200, 55), "   Overwrite?"
      _PRINTSTRING (200, 70), "  YES   NO"
      P2 = _KEYHIT
      Done = 0
      SELECT CASE P2
        CASE 256 * 75: OverSel = 1
        CASE 256 * 77: OverSel = 0
        CASE 89, 121 '   Y
          OverSel = 1
          Done = 1
        CASE 27, 78, 110 '   N   (ESC)
          OverSel = 0
          Done = 1
        CASE 32, 13
          Done = 1
      END SELECT
      SELECT CASE OverSel
        CASE 0
          _PRINTSTRING (250, 70), CHR$(16)
        CASE 1
          _PRINTSTRING (200, 70), CHR$(16)
      END SELECT
      _LIMIT 30
      _PUTIMAGE (0, 0)-(799, 599), FilePage, 0

    LOOP UNTIL Done = 1
  END IF

  IF OverSel = 0 AND Original = 0 THEN: Good = 0

  IF Original = 1 THEN
    IF _FILEEXISTS(DataDir + "files.jml") THEN

      FileList(Count + 1) = UCASE$(NewFile$)
      Limit = Count + 1
      DO
        Switch = 0
        FOR i = 1 TO (Limit - 1)
          IF FileList(i) > FileList(i + 1) THEN
            SWAP FileList(i), FileList(i + 1)
            Switch = i
          END IF
        NEXT
        Limit = Switch
      LOOP WHILE Switch

      OPEN DataDir + "files.jml" FOR OUTPUT AS #1
      FOR i = 1 TO Count + 1
        WRITE #1, FileList(i)
      NEXT
      CLOSE #1

    ELSE
      OPEN DataDir + "files.jml" FOR OUTPUT AS #1
      WRITE #1, UCASE$(NewFile$)
      CLOSE #1
    END IF
    CurrentFile = NewFile$
  END IF

  IF Good = 1 THEN
    OPEN PicDir + NewFile$ + ".jml" FOR BINARY AS #1
    PUT #1, , EditType
    FOR i = 1 TO 8
      _SOURCE Picture(i)
      SELECT CASE EditType
        CASE 1
          FOR X = 0 TO 29
            FOR Y = 0 TO 19
              TempPicWep(X, Y) = POINT(X, Y)
            NEXT
          NEXT
          PUT #1, , TempPicWep()
        CASE 0
          FOR X = 0 TO 149
            FOR Y = 0 TO 99
              TempPic(X, Y) = POINT(X, Y)
            NEXT
          NEXT
          PUT #1, , TempPic()
      END SELECT
    NEXT
    CLOSE #1
  END IF

END IF

RETURN

LoadPic:
IF _FILEEXISTS(DataDir + "files.jml") THEN
  Count = 0
  OPEN DataDir + "files.jml" FOR INPUT AS #1
  DO
    Count = Count + 1
    INPUT #1, FileList(Count)
  LOOP UNTIL EOF(1)
  CLOSE #1
  _DEST FilePage
  FirstTime = 1

  DO
    CLS
    _PRINTSTRING (190, 0), "LOAD"
    FOR i = Sel - 8 TO Sel + 8
      IF i >= 1 AND i <= Count THEN
        C& = (9 - ABS(Sel - i)) * 28
        COLOR _RGB32(C&, C&, C&)
        _PRINTSTRING (25, 125 + (i - Sel) * 15), UCASE$(LEFT$(FileList(i), 1)) + LCASE$(RIGHT$(FileList(i), LEN(FileList(i)) - 1))
      END IF
    NEXT
    COLOR _RGB32(255, 255, 255)
    _PRINTSTRING (5, 125), CHR$(16)
    Press = _KEYHIT
    Done = 0
    OldSel = Sel
    SELECT CASE Press
      CASE 256 * 72: Sel = Sel - 1
      CASE 256 * 80: Sel = Sel + 1
      CASE 256 * 83 ' DEL
        DO
          _PRINTSTRING (200, 40), "Delete File!"
          _PRINTSTRING (200, 55), "Are you sure?"
          _PRINTSTRING (200, 70), "  YES   NO"
          P2 = _KEYHIT
          Done = 0
          SELECT CASE P2
            CASE 256 * 75: DelSel = 1
            CASE 256 * 77: DelSel = 0
            CASE 89, 121 '  Y
              DelSel = 1
              Done = 1
            CASE 78, 110 '   N
              DelSel = 0
              Done = 1
            CASE 27
              DelSel = 0
              Done = 1
            CASE 32, 13
              Done = 1
          END SELECT
          SELECT CASE DelSel
            CASE 0
              _PRINTSTRING (250, 70), CHR$(16)
            CASE 1
              _PRINTSTRING (200, 70), CHR$(16)
          END SELECT
          _LIMIT 30
          _PUTIMAGE (220, 100), LoadPic(5), FilePage
          _PUTIMAGE (0, 0)-(799, 599), FilePage, 0

        LOOP UNTIL Done = 1
        IF DelSel = 1 THEN
          DelSel = 0
          IF _FILEEXISTS(PicDir + FileList(Sel) + ".jml") THEN
            KILL PicDir + FileList(Sel) + ".jml"
          END IF
          FileList(Sel) = FileList(Count)
          Count = Count - 1

          Limit = Count
          DO
            Switch = 0
            FOR i = 1 TO (Limit - 1)
              IF FileList(i) > FileList(i + 1) THEN
                SWAP FileList(i), FileList(i + 1)
                Switch = i
              END IF
            NEXT
            Limit = Switch
          LOOP WHILE Switch

          OPEN DataDir + "files.jml" FOR OUTPUT AS #1
          FOR i = 1 TO Count
            WRITE #1, FileList(i)
          NEXT
          CLOSE #1
          IF Count = 0 THEN
            IF _FILEEXISTS(DataDir + "files.jml") THEN: KILL DataDir + "files.jml"
          END IF

        END IF
      CASE 27: Done = 2
      CASE 32, 13: Done = 1
    END SELECT
    IF Sel < 1 THEN: Sel = 1
    IF Sel > Count THEN: Sel = Count

    IF Sel <> OldSel OR FirstTime = 1 THEN
      FirstTime = 0
      OPEN PicDir + FileList(Sel) + ".jml" FOR BINARY AS #1
      GET #1, , EditType
      FOR i = 1 TO 8
        SELECT CASE EditType
          CASE 0
            GET #1, , TempPic()
            _DEST LoadPic(i)
            CLS
            FOR X = 0 TO 149
              FOR Y = 0 TO 99
                PSET (X, Y), TempPic(X, Y)
              NEXT
            NEXT
          CASE 1
            GET #1, , TempPicWep()
            _DEST LoadPicWep(i)
            CLS
            FOR X = 0 TO 29
              FOR Y = 0 TO 19
                PSET (X, Y), TempPicWep(X, Y)
              NEXT
            NEXT

        END SELECT
      NEXT
      CLOSE #1
      _DEST FilePage
    END IF

    Frame = Frame + 1
    IF Frame = 60 THEN: Frame = 1
    _LIMIT 30

    IF Frame MOD 5 = 1 THEN
      CurFrame = CurFrame + 1
      IF CurFrame = 9 THEN: CurFrame = 1
    END IF
    SELECT CASE EditType
      CASE 0
        _PUTIMAGE (220, 100), LoadPic(CurFrame), FilePage
      CASE 1
        _PUTIMAGE (220, 100)-(370, 200), LoadPicWep(CurFrame), FilePage
    END SELECT
    _PUTIMAGE (0, 0)-(799, 599), FilePage, 0

  LOOP UNTIL Done > 0

  _DEST Layer

  IF Done = 1 THEN
    CurrentFile = FileList(Sel)
    OPEN PicDir + FileList(Sel) + ".jml" FOR BINARY AS #1
    GET #1, , EditType
    FOR i = 1 TO 8
      SELECT CASE EditType
        CASE 0
          GET #1, , TempPic()
          _DEST Picture(i)
          FOR X = 0 TO 149
            FOR Y = 0 TO 99
              PSET (X, Y), TempPic(X, Y)
            NEXT
          NEXT
        CASE 1
          GET #1, , TempPicWep()
          _DEST Picture(i)
          FOR X = 0 TO 29
            FOR Y = 0 TO 19
              PSET (X, Y), TempPicWep(X, Y)
            NEXT
          NEXT
      END SELECT
    NEXT
    CLOSE #1
    _DEST Layer
  END IF
ELSE
  _DEST 0
  LINE (200, 200)-(335, 220), _RGB32(0, 0, 0), BF
  LINE (200, 200)-(335, 220), _RGB32(255, 255, 0), B
  _PRINTSTRING (203, 202), "No Files To Load"
  _DELAY 1
  _DEST Layer
END IF

RETURN

SUB Mouse
DO WHILE _MOUSEINPUT
  MouseX = _MOUSEX
  MouseY = _MOUSEY
  MouseLB = _MOUSEBUTTON(1)
  MouseMB = _MOUSEBUTTON(3)
  MouseRB = _MOUSEBUTTON(2)
  MouseScrl = MouseScrl + _MOUSEWHEEL
LOOP
IF MouseScrl < -1 THEN: MouseScrl = -1
IF MouseScrl > 1 THEN: MouseScrl = 1
END SUB

SUB MakeColorWheel

DIM Center(3, 2) AS INTEGER, Col AS LONG

Center(1, 1) = 250 + COS(330 / Rad) * 200
Center(1, 2) = 250 + SIN(330 / Rad) * 200
Center(2, 1) = 250 + COS(210 / Rad) * 200
Center(2, 2) = 250 + SIN(210 / Rad) * 200
Center(3, 1) = 250 + COS(90 / Rad) * 200
Center(3, 2) = 250 + SIN(90 / Rad) * 200

_DEST ColorWheel
FOR X = 0 TO 500
  FOR Y = 0 TO 500
    DistR = Distance(Center(1, 1), Center(1, 2), X, Y)
    DistG = Distance(Center(2, 1), Center(2, 2), X, Y)
    DistB = Distance(Center(3, 1), Center(3, 2), X, Y)
    R = 655 - DistR * 2
    G = 655 - DistG * 2
    B = 655 - DistB * 2
    Col = _RGB32(R, G, B)
    IF Distance(250, 250, X, Y) < 250 THEN: PSET (X, Y), Col
  NEXT
NEXT

END SUB

FUNCTION Distance (X1, Y1, X2, Y2)
Distance = SQR((X1 - X2) * (X1 - X2) + (Y1 - Y2) * (Y1 - Y2))
END FUNCTION

FUNCTION Angle (X1, Y1, X2, Y2)
Ang = ATN((X1 - X2) / (Y1 - Y2)) * Rad
IF Y1 < Y2 THEN
  Angle = 90 - Ang
ELSE
  Angle = 270 - Ang
END IF
END FUNCTION



